#!/usr/bin/perl

use utf8;
open TSV, "<:utf8", $ARGV[0] or die $!;
open WORDPART, "<:utf8", $ARGV[1] or die $!;
binmode STDOUT, ":utf8";

while($tsv = <TSV> and $wp = <WORDPART>) {
    chomp $tsv; chomp $wp;
    my ($name,$tag) = split(/\t/,$tsv);
    my $result;
    my @arr = split(/ +/,$wp);
    my (@out,$type);
    for(@arr) {
        if(/\/(人名|地名)/ or /^(\p{InHiragana}|\p{InKatakana}|\p{InCJKUnifiedIdeographs})+\/UNK/ or (@out and /\/接尾辞/)) {
            if(not $type) {
                if(/\/人名/) { $type = "person"; }
                elsif(/\/地名/) { $type = "location"; }
            }
            s/\/[^ \/]+//g;
            $_ = " " if not $_;
            push @out, $_;
        } else {
            if(@out) {
                $type = "other" if not $type;
                $result .= "<$type>".join(//,@out)."</$type>";
                @out = ();
                $type = 0;
            }
            s/\/[^ \/]+//g;
            $_ = " " if not $_;
            $result .= $_;
        }
    }
    if (@out) {
        $type = "other" if not $type;
        $result .= "<$type>".join(//,@out)."</$type>";
    }
    print "$name\t$tag\t$result\n";
}
